//*************************************************************
//  File name: global.h
//*************************************************************

#include <windows.h>
#include <commdlg.h>

#define _GLOBALINC


    BOOL            ShowPrintSetup (HWND hWnd);
    BOOL            ShowPrintBox (HWND hWnd);
    BOOL            PrintIt(HWND hWnd, LPPRINTDLG lpPD);
    HDC             GetPrinterDC (void);
    int  FAR PASCAL PrintAbortDlg (HWND hWnd, unsigned msg, WORD wParam, LONG lParam);
    BOOL FAR PASCAL PrintAbortProc (HDC hDC, short code);



// global structure for printing attributes
typedef struct 
{
   HANDLE  hCurrDevMode, hCurrDevNames;
   HFONT   hPrinterFont;
   LOGFONT lfCurrFont;
   char    szPrinter [64] ;
   LPSTR   szDevice, szDriver, szOutput ;
   BOOL    bAbort;
   HWND    hDlgAbort;

} PRINTINFOSTRUCT;


// global structure for screen attributes
typedef struct 
{
   HFONT    hScreenFont;
   LOGFONT  lfCurrFont;
   COLORREF crTextColor;

} SCREENINFOSTRUCT;


/*** EOF: global.h ***/

